// dllmfc.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "dllmfc.h"

#include "dialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//
//	Note!
//
//		If this DLL is dynamically linked against the MFC
//		DLLs, any functions exported from this DLL which
//		call into MFC must have the AFX_MANAGE_STATE macro
//		added at the very beginning of the function.
//
//		For example:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//			// normal function body here
//		}
//
//		It is very important that this macro appear in each
//		function, prior to any calls into MFC.  This means that
//		it must appear as the first statement within the 
//		function, even before any object variable declarations
//		as their constructors may generate calls into the MFC
//		DLL.
//
//		Please see MFC Technical Notes 33 and 58 for additional
//		details.
//

/////////////////////////////////////////////////////////////////////////////
// CDllmfcApp

BEGIN_MESSAGE_MAP(CDllmfcApp, CWinApp)
	//{{AFX_MSG_MAP(CDllmfcApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDllmfcApp construction

CDllmfcApp::CDllmfcApp()
{
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CDllmfcApp object

CDllmfcApp theApp;


typedef struct
{
	int nev;	// number of elements
	int nn1;	// dimension of element array
	int npv;	// number of nodes
	int **nel;	// elements nel[nev+1][nn1]: nel[0] not used, single array for all elements
	float (*pkt)[3];	// node coordinates pkt[npv+1][3]: pkt[0] not used
} festruct;


extern "C"
void funct2(CWnd *pWnd,festruct *p1,festruct *p2,int kzfree)
{
	if(kzfree)
	{
		delete [] p2->nel[0];
		delete [] p2->nel;
		delete [] p2->pkt;
		return;
	}

	DllDlg dlg(pWnd);

	dlg.DoModal();

	float z = dlg.m_wert;

	int nev = p1->nev;
	int npv = p1->npv;
	int **nel = p1->nel;
	int nn1 = p1->nn1;
	float (*pkt)[3] = p1->pkt;

	if(!nev || !nn1 || !npv) return;

	p2->nev = nev;
	p2->npv = npv;
	p2->nn1 = nn1;
	p2->nel = (int **) new char[(nev+1)*sizeof(int *)];
	p2->nel[0] = new int[nn1*(nev+1)*sizeof(int)];
	for(int k=1;k<=nev;k++) p2->nel[k] = p2->nel[k-1] + nn1;
	p2->pkt = new float[npv+1][3];

	memcpy(p2->nel[0],p1->nel[0],nn1*(nev+1)*sizeof(int));
	memcpy(p2->pkt,p1->pkt,3*(npv+1)*sizeof(float));

	for(k=1;k<=npv;k++) p2->pkt[k][2] += z;   // translation
	for(k=1;k<=nev;k++) p2->nel[k][3] = 1000; // group ID

	return ;
}
